/*
// EF_Image.c
//
// $Id: EF_Image.c,v 1.3 1998/02/08 23:12:57 mmp Exp $
*/


#include "EF_Image.h"
#include <stdlib.h>
#include <stdio.h>

EF_Image *newEF_Image(short xSize, short ySize)
{
  EF_Image *im = (EF_Image *)malloc(sizeof(EF_Image));
  if (im!=NULL)
    {
      im->pixels=(FOUR_BYTES *) malloc(sizeof(FOUR_BYTES)*xSize*ySize);
      if (im->pixels==NULL)
        {
          free(im);
          im=NULL;
        }

      im->xSize = xSize;
      im->ySize = ySize;
    }
  return im;
}


void deleteEF_Image(EF_Image *image)
{
  if (image!=NULL)
    {
    if (image->pixels != NULL)
      {
	free(image->pixels);
	image->pixels=NULL;
      }
    
    free(image);
    }
  
}

  
void copyEF_Image(EF_Image *src, EF_Image *dst)
{
  int i;
  if (src->xSize!=dst->xSize || src->ySize!=dst->ySize)
    {
      fprintf(stderr, "copyEF_Image: images must be the same resolution\n");
      exit(1);
    }
  
 for ( i=0; i< src->xSize * src->ySize; i++)
    dst->pixels[i]=src->pixels[i];
 
}

void blackEF_Image(EF_Image *src)
{
  int i;
  
 for ( i=0; i< src->xSize * src->ySize; i++)
   src->pixels[i]=0x000000FF;
 
}
