#include "movieMunge.h"


#include "EF_Image.h"
#include "EF_Movie.h"

void movieGetRotatedFrame(char *filename, short frame, EF_Image *im)
{
  EF_Image *tmpim;
  EF_Image *loadim;
  long *pix;
  
  // Load a movie
     loadim=movieLoad(filename,frame);
     movieXBGRtoRGBA(loadim);
     
     // Fix the size of the passed in image
     // Allocate a new image, swap the memory with the
     // old one, and delete the old space
     if (im->xSize != loadim->ySize || im->ySize != loadim->xSize)
       {
	 
     tmpim=newEF_Image(loadim->ySize,loadim->xSize);
     pix=im->pixels;
     im->pixels=tmpim->pixels;
     tmpim->pixels=pix;
     im->xSize=tmpim->xSize;
     im->ySize=tmpim->ySize;
     deleteEF_Image(tmpim);
       }
     
     // Copy the pixels from loadim to im flipping horz.
     for (int i=0;i<im->xSize;i++)
       for (int j=0;j<im->ySize;j++)
	 {
	   EF_ImageXY(im,i,j)=EF_ImageXY(loadim,j,i);
	   
	 }
     
     // delete the load image
     deleteEF_Image(loadim);
}


int movieLoadFrames(EF_Image **frames, char *filename)
{
  int numFrames=movieNumFrames(filename);
  int xs=100;
  int ys=100;
  

  
  for (int i=0; i< numFrames; i++)
    {
      frames[i]=newEF_Image(xs,ys);
      movieGetRotatedFrame(filename, i, frames[i]);
      xs=frames[i]->xSize;
      ys=frames[i]->ySize;
     
    }
  return numFrames;
  
}

