//
// effects.C
//
// $Id: effects.C,v 1.6 1998/02/11 02:49:24 jedavis Exp $
//



#include <stdlib.h>

#include <dlfcn.h>
#include <stdio.h>
#include <string.h>
#include <GL/gl.h>
#include <glut.h>
#include <dirent.h>
#include <ctype.h>
#include <tiffio.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <errno.h>
#include "EF_Image.h"
#include "EF_Movie.h"
#include "movieMunge.h"

#define MAXFRAMES 1024

int gCurFrame =0;
int gWindowWidth;
int gWindowHeight;
EF_Image *movieFrames[MAXFRAMES];
int gNumFrames;
char gFilename[1024];
int gLoaded=0;
int gDisplayed =0;
int gClickX;

void displayEditCallback()
{
  // draw
  EF_Image *image=movieFrames[gCurFrame];
  int xs=image->xSize;
  
    glRasterPos2f(0, image->ySize);
    glPixelZoom(1, -1);
    glDrawPixels(image->xSize,image->ySize, GL_RGBA, GL_UNSIGNED_BYTE,
		 image->pixels);

    // Draw some more context
    if (gLoaded)
      {
	int numparts =gWindowWidth/xs;
	
	for (int i=1; i<numparts;i++)
	  {
	    image=movieFrames[(gCurFrame+i)%gNumFrames];
	    
	    glRasterPos2f(xs*i, image->ySize);
	    glPixelZoom(1, -1);
	    glDrawPixels(image->xSize,image->ySize, GL_RGBA, GL_UNSIGNED_BYTE,
			 image->pixels);
	    
	  }
	
      }
    
    gDisplayed=1;
}

void reshapeCallback(GLint w, GLint h)
{
    glViewport(0, 0, w, h);

    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    glOrtho(0, w, 0, h, -1.0, 1.0);

    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();
    gWindowWidth = w;
    gWindowHeight = h;
    
    // make a nice size
    if (gLoaded)
      {
	int width=(w/movieFrames[0]->xSize);
	if (width<1) width=1;
	if (width>gNumFrames) width=gNumFrames;
	width=width*movieFrames[0]->xSize;
	glutReshapeWindow(width,movieFrames[0]->ySize);
      }
    
}

void idleCallback()
{
  if (!gLoaded && gDisplayed)
    {
      // delete that one frame we loaded
      deleteEF_Image(movieFrames[0]);
      
      // load the whole set of images
      gNumFrames=movieLoadFrames(movieFrames,gFilename);
  

      // Set the loaded state
      gLoaded=1;
  
      // Deregister the idle function
      glutIdleFunc(NULL);
  
      // Resize window and redisplay
      int numWide = 450/movieFrames[0]->xSize;
      
      glutReshapeWindow(movieFrames[0]->xSize*numWide,movieFrames[0]->ySize);
      glutPostRedisplay();
  
    }
  
}

void mouseCallback(int button, int state, int x, int y)
{
gClickX=x;
}

void motionCallback(int x, int y)
{
  if (!gLoaded) return;
  
  if (x>gClickX+10)
    {
      gCurFrame=(gCurFrame+1)%gNumFrames;
      gClickX=x;
    }
  
  else if (x<gClickX-10)
    {
      gCurFrame=(gCurFrame-1+gNumFrames)%gNumFrames;
      gClickX=x;
    }
  

  glutPostRedisplay();
 
}

void specialCallback(int key, int x, int y)
{
  if (key==GLUT_KEY_LEFT)
    {
      gCurFrame=(gCurFrame-1+gNumFrames)%gNumFrames;
      glutPostRedisplay();
    }
  else if (key==GLUT_KEY_RIGHT)
    {
      gCurFrame=(gCurFrame+1)%gNumFrames;
      glutPostRedisplay();
    }
}

main (int argc, char *argv[])
{
  int gEditWindow;
  int numberOfFrames;
  
  
  // Check parameters
if (argc!=2)
  {
    fprintf(stderr,"Usage: qtvr <filename>\n");
    exit(2);
  }
 
 strcpy(gFilename,argv[1]);

    // Load the first movie frame 
     movieFrames[0]=newEF_Image(100,100);
     movieGetRotatedFrame(gFilename,0,movieFrames[0]);
 
 
 // construct a final mosaic
 int xsize=movieFrames[0]->xSize;
 int ysize=movieFrames[0]->ySize;
  
     // Initialize GLUT Windows
    glutInit(&argc, argv);
    glutInitDisplayMode(GLUT_RGB);
    glutInitWindowSize(xsize,ysize);
     gEditWindow = glutCreateWindow("QTVR Viewer - jedavis@cs.stanford.edu");
    glutDisplayFunc(displayEditCallback);
    glutReshapeFunc(reshapeCallback);
    glutIdleFunc(idleCallback);
    glutMouseFunc(mouseCallback);
    glutMotionFunc(motionCallback);
    glutSpecialFunc(specialCallback);
    
    // Main Loop
    glutMainLoop();
 
    // Compiler bait
    gEditWindow=gEditWindow;
    
}

